<?

/*
This file is part of the UMS Project for University of Cergy-Pontoise
Copyright 2005, Jean-Baptiste Langlois <jeanbaptiste.langlois@wanadoo.fr>
Copyright 2005, Jean-Philippe Aumasson <jpnossa@free.fr>

UMS is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

UMS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with UMS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/**
 * Class to manage courses for teachers in a university
 * @author Jean-Baptiste Langlois <jeanbaptiste.langlois@gmail.com>
 * @version 1.41
 * @since 2004-02-12
 * @license http://opensource.org/licenses/gpl-license.php GNU Public License
 * @package ums
 */

class Course {

        var $id;

        /**
         * Constructor for the Course class
         * @param integer $id
         */
        
        function Course($no) {

                $this->id = $no;

        }
        
        /**
         * Method to add a new course to the database
         * @param string $name
         * @param integer $career_id
         * @param integer $diploma_id
         * @param integer $coefficient
         * @param char $type_course (E,F,N)
         * @param integer $period_of_year
         */

        function addCourse($title,$career,$diploma,$coef,$typec,$period) {
                
                include "config.php";
                $dblink=mysql_connect($servername,$username,$password);
                if (!$dblink)
                {
                        die("Connection error :".mysql_error());
                }
                mysql_select_db($database,$dblink);
                $no=1;
                $query=mysql_query("SELECT ID FROM `Course` WHERE ID=\"".$no."\";",$dblink);
                $result=mysql_fetch_array($query);
                // Search for the first unused ID
                while ($result["ID"]!="")
                {
                        $no++;
                        $query=mysql_query("SELECT ID FROM `Course` WHERE ID=\"".$no."\";",$dblink);
                        $result=mysql_fetch_array($query);
                }
                $this->id=$no;
                // if $typec is different for E (Eliminatory), F (Optional) and N (Obligatory)
                // the query won't be executed
                $query=mysql_query("INSERT INTO `Course` VALUES(\"".$this->id."\", \"$title\",\"$career\",\"$diploma\",\"$coef\",\"$typec\",\"$period\");",$dblink);
                mysql_close($dblink);

        }

        /**
         * Method to remove the current course from the database
         */

        function removeCourse() {
                
                include "config.php";
                if ($this->id != 0)
                {
                        $dblink=mysql_connect($servername,$username,$password);
                        if (!$dblink)
                        {
                                die("Connection error :".mysql_error());
                        }
                        mysql_select_db($database,$dblink);
                        $query=mysql_query("DELETE FROM `Course` WHERE ID=\"".$this->id."\";",$dblink);
                        mysql_close($dblink);
                }

        }
        
        /**
         * Accessor to get the type of the current course
         * @return char
         */
        
        function getCourseType() {
                
                include "config.php";
                $dblink=mysql_connect($servername,$username,$password);
                if (!$dblink)
                {
                        die("Connection error :".mysql_error());
                }
                mysql_select_db($database,$dblink);
                $query=mysql_query("SELECT typecourse FROM `Course` WHERE ID=\"".$this->id."\";",$dblink);
                $result=mysql_fetch_array($query);
                mysql_close($dblink);
                // Will be F, E, or N
                return $result[0];
        }
        
        /**
         * Accessor to get the name of the current course
         * @return string
         */

        function getTitle() {
                
                include "config.php";
                $dblink=mysql_connect($servername,$username,$password);
                if (!$dblink)
                {
                        die("Connection error :".mysql_error());
                }
                mysql_select_db($database,$dblink);
                $query=mysql_query("SELECT title FROM `Course` WHERE ID=\"".$this->id."\";",$dblink);
                $result=mysql_fetch_array($query);
                mysql_close($dblink);
                return $result[0];

        }
        
        /**
         * Accessor to get the ID of the current course
         * @return integer
         */

        function getID() {
                
                if ($this->id != 0) return $this->id;
                
        }
        
        /**
         * Accessor to get the ID of the career which the course is dispensed in
         * @return integer
         */ 
	
	function getCareer() {
                
                include "config.php";
                $dblink=mysql_connect($servername,$username,$password);
                if (!$dblink)
                {
                        die("Connection error :".mysql_error());
                }
                mysql_select_db($database,$dblink);
                $query=mysql_query("SELECT career FROM `Course` WHERE ID=\"".$this->id."\";",$dblink);
                $result=mysql_fetch_array($query);
                mysql_close($dblink);
                return $result[0];
                
        }
        
        /**
         * Accessor to get the ID of the diploma which will be brought by following the course
         * @return integer
         */ 
	
	function getDiploma() {
                
                include "config.php";
                $dblink=mysql_connect($servername,$username,$password);
                if (!$dblink)
                {
                        die("Connection error :".mysql_error());
                }
                mysql_select_db($database,$dblink);
                $query=mysql_query("SELECT diploma FROM `Course` WHERE ID=\"".$this->id."\";",$dblink);
                $result=mysql_fetch_array($query);
                mysql_close($dblink);
                return $result[0];
        }
        
        /**
         * Accessor to get the coefficient of the current course
         * @return integer
         */
	
	function getCoef() {
                
                include "config.php";
                $dblink=mysql_connect($servername,$username,$password);
                if (!$dblink)
                {
                        die("Connection error :".mysql_error());
                }
                mysql_select_db($database,$dblink);
                $query=mysql_query("SELECT coef FROM `Course` WHERE ID=\"".$this->id."\";",$dblink);
                $result=mysql_fetch_array($query);
                mysql_close($dblink);
                return $result[0];
                
        }
        
        /**
         * Accessor to get the period of the current course
         * @return integer
         */
	
	function getPeriod() {
                include "config.php";
                $dblink=mysql_connect($servername,$username,$password);
                if (!$dblink)
                {
                        die("Connection error :".mysql_error());
                }
                mysql_select_db($database,$dblink);
                $query=mysql_query("SELECT period FROM `Course` WHERE ID=\"".$this->id."\";",$dblink);
                $result=mysql_fetch_array($query);
                mysql_close($dblink);
                return $result[0];
                
        }
        
        /**
         * Method to test if the current course is dispensed in a certain period
         * @param integer $period
         * @return true|false
         */
        
        function isPeriod($rightnow) {
                
                include "config.php";
                $dblink=mysql_connect($servername,$username,$password);
                if (!$dblink)
                {
                        die("Connection error :".mysql_error());
                }
                mysql_select_db($database,$dblink);
                $query=mysql_query("SELECT ID FROM `Course` WHERE ID=\"".$this->id."\" AND period=\"$rightnow\";",$dblink);
                $result=mysql_fetch_array($query);
                mysql_close($dblink);
                if ($result[0]!=0) {
                        return true;
                } else {
                        return false;
                }
                
        }
        
        /**
         * Method to get the ID from a name given as a parameter
         * BEWARE using it since a name might not be unique
         * @param string $name
         * @return integer
         * @author Jean-Philippe Aumasson <jpnossa@free.fr>
         * @since 2004-12-08
         */
	
        function searchID($name) {
                
                include "config.php";
                $dblink=mysql_connect($servername,$username,$password);
                if (!$dblink)
                {
                        die("Connection error :".mysql_error());
                }
                mysql_select_db($database,$dblink);
                $query=mysql_query("SELECT ID FROM `Course` WHERE title=\"".$name."\";",$dblink);
                $result=mysql_fetch_array($query);
                mysql_close($dblink);
                $this->id=$result[0];
                return $result[0];     
                
        }
        
        /**
         * Method to get the ID from a name and a period given as a parameter
         * BEWARE using it since a name might not be unique
         * @param string $name
         * @param integer $period
         * @return integer
         * @todo remove it
         */
        
        function getIDFromStuff($nom,$yea) {
                
                include "config.php";
                $dblink=mysql_connect($servername,$username,$password);
                if (!$dblink)
                {
                        die("Connection error :".mysql_error());
                }
                mysql_select_db($database,$dblink);
                $query=mysql_query("SELECT ID FROM `Course` WHERE title=\"$nom\" AND period=\"$yea\";",$dblink);
                //echo "SELECT ID FROM `Course` WHERE title=\"$nom\" AND period=\"$yea\";";
                $result=mysql_fetch_array($query);
                $this->id=$result[0];
                mysql_close($dblink);
                return $result[0];     
                
        }

}

?>
